/*****************************************************************************
 * Twisted Twistor is Twisting/Camelot
 * Code: Cruzer/CML
 * Asm'ed with: KickAss 2.25
 * Released: 2008-01-03
 *****************************************************************************/

.var barCnt =		$02
.var cnt =		$03
.var p0 =		$05
.var barOrder =		$07
.var cntStart =		$08
.var hia =		$0b
.var lo =		$0c
.var buffer =		$10

.var code =		$0801
.var screen =		$0c00
.var sine128 =		$1200
.var bitmap =		$2000

.pc = code "code"
//------------------------------------------------------------------------------
.var screenWidth = 40
.var screenHeight = 25
.var offsetX = 4
.var offsetAdr = screen //+ offsetX

.var sineStarts = List().add(0,77)
.var sineSpreads = List().add(-1,2)
.var sineSpeeds = List().add(2,3)
//------------------------------------------------------------------------------
basic:			.by $0b,$08,$39,$05,$9e,$32,$30,$39,$35,$00,$00
//------------------------------------------------------------------------------
colors0:		.by $00,$06,$6b,$6c,$ec,$fe,$ff,$f1,$11
			.by $f1,$ff,$fe,$ec,$6c,$6b,$06
colors1:		.by $00,$02,$22,$2a,$aa,$a7,$77,$71,$11
			.by $71,$77,$a7,$aa,$2a,$22,$02,$00
colorAdrs:		.by <colors0,<colors1
//------------------------------------------------------------------------------
start:
			sei
			
//fill bitmap...
!:
			lda #%01010101
sbm:			sta bitmap-$100,x
			lda #$00
			.by STA_ABSX,$02,$00 //sta $0002,x
			inx
			bne !-
			inc sbm+2
			bpl !-

			txa
			pha			

//calc "sine"...
			ldy #$ff
!loop:	
loa:			lda #$15
			adc #$07
			sta $d020
			sta loa+1
			bcc !+
			inc hia
			clc
!:
			adc lo
			sta lo
			pla
			adc hia
			pha
			sta sine128,x
			sta sine128,y
			eor #$7f
			sta sine128+$80,x
			sta sine128-$80,y
			inx
			dey
			cpx #$40
			bne !loop-

// copy sine
			ldx #0
!:			lda sine128,x
			sta sine128+$100,x
			inx
			bne !-

			lda #$3b
			sta $d011
			sta $d018

//------------------------------------------------------------------------------
mainLoop:
			.for (var s=0; s<2; s++) {			
				.for (var i=0; i < sineSpeeds.get(s); i++) {
					inc cntStart + s
				}
				.for (var i=0; i > sineSpeeds.get(s); i--) {
					dec cntStart + s
				}
			}

			lda #>screen
			sta p0+1
			
			ldx #$02
!:			lda cntStart,x
			sta cnt,x
			dex
			bpl !-
!yLoop:
!barLoop:
			lax cnt+1
			clc
			adc sine128 + sineStarts.get(1),x
			ldx cnt+0
			clc
			adc sine128 + sineStarts.get(0),x
			tax
			
			and #$80
			sta barOrder
			
			txa
			eor barCnt
			eor barOrder
			tay
			lda sine128,y
			lsr
			lsr
			lsr
			tax
			
			lda barCnt
			eor barOrder
			asl
			rol
			tay
			lda colorAdrs,y
			sta lcl+1
			
			ldy #$10
!xLoop:
lcl:			lda colors0,y
			sta buffer+offsetX,x
			inx
			dey
			bpl !xLoop-
			
			lda barCnt
			eor #$80
			sta barCnt
			bmi !barLoop-

			ldy #39
!:			lda buffer,y
			sta (p0),y
			lda #$55
			sta buffer,y
			dey
			bpl !-
			
			.for (var s=0; s<2; s++) {			
				.for (var i=0; i < sineSpreads.get(s); i++) {
					inc cnt+s
				}
				.for (var i=0; i > sineSpreads.get(s); i--) {
					dec cnt+s
				}
			}
			
			lda #screenWidth
			clc
			adc p0+0
			sta p0+0
			bcc !+
			inc p0+1
!:			cmp #<[offsetAdr + screenWidth * screenHeight]
			bne !yLoop-
	
			beq mainLoop
